import typer
from orchestrator import OrchestratorCore, app_settings
from orchestrator.cli.main import app as cli_app

import gso.products  # noqa: F401
import gso.workflows  # noqa: F401
from gso.api import router as api_router
from gso.cli import netbox


def init_gso_app() -> OrchestratorCore:
    app = OrchestratorCore(base_settings=app_settings)
    app.include_router(api_router, prefix="/api")
    return app


def init_worker_app() -> OrchestratorCore:
    return OrchestratorCore(base_settings=app_settings)


def init_cli_app() -> typer.Typer:
    from gso.cli import import_sites

    cli_app.add_typer(import_sites.app, name="import_sites")
    cli_app.add_typer(netbox.app, name="netbox-cli")
    return cli_app()
